rved"/>
      </rule>
      <rule pattern="[aDiLpqsStux]\:">
        <token type="KeywordReserved"/>
      </rule>
      <rule pattern="(_[0-9])\:">
        <token type="KeywordConstant"/>
      </rule>
      <rule pattern="\(">
        <token type="Punctuation"/>
        <push state="parentheses"/>
      </rule>
      <rule>
        <include state="numbers"/>
      </rule>
    </state>
    <state name="comment">
      <rule pattern="[^)]">
        <token type="CommentMultiline"/>
      </rule>
      <rule pattern="^\)">
        <token type="CommentMultiline"/>
        <pop depth="1"/>
      </rule>
      <rule pattern="[)]">
        <token type="CommentMultiline"/>
      </rule>
    </state>
    <state name="explicitDefinition">
      <rule pattern="\b[nmuvxy]\b">
        <token type="NameDecorator"/>
      </rule>
      <rule>
        <include state="root"/>
      </rule>
      <rule pattern="[^)]">
        <token type="Name"/>
      </rule>
      <rule pattern="^\)">
        <token type="NameLabel"/>
        <pop depth="1"/>
      </rule>
      <rule pattern="[)]">
        <token type="Name"/>
      </rule>
    </state>
    <state name="numbers">
      <rule pattern="\b_{1,2}\b">
        <token type="LiteralNumber"/>
      </rule>
      <rule pattern="_?\d+(\.\d+)?(\s*[ejr]\s*)_?\d+(\.?=\d+)?">
        <token type="LiteralNumber"/>
      </rule>
      <rule pattern="_?\d+\.(?=\d+)">
        <token type="LiteralNumberFloat"/>
      </rule>
      <rule pattern="_?\d+x">
        <token type="LiteralNumberIntegerLong"/>
      </rule>
      <rule pattern="_?\d+">
        <token type="LiteralNumberInteger"/>
      </rule>
    </state>
    <state name="nounDefinition">
      <rule pattern="[^)]">
        <token type="LiteralString"/>
      </rule>
      <rule pattern="^\)">
        <token type="NameLabel"/>
        <pop depth="1"/>
      </rule>
      <rule pattern="[)]">
        <token type="LiteralString"/>
      </rule>
    </state>
    <state name="parentheses">
      <rule pattern="\)">
        <token type="Punctuation"/>
        <pop depth="1"/>
      </rule>
      <rule>
        <include state="explicitDefinition"/>
      </rule>
      <rule>
        <include state="root"/>
      </rule>
    </state>
  </rules>
</lexer>